/*************************************************************************
 *
 *  $RCSfile: offmgr_fontsubstconfig.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 10:56:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _OFA_FONTSUBSTCONFIG_HXX
#include <fontsubstconfig.hxx>
#endif
#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif

// auto strip #ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
// auto strip #include <com/sun/star/beans/PropertyValue.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UNO_ANY_HXX_
// auto strip #include <com/sun/star/uno/Any.hxx>
// auto strip #endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
namespace binfilter {

using namespace utl;
using namespace rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::beans;

#define C2U(cChar) OUString::createFromAscii(cChar)

const sal_Char cReplacement[] = "Replacement";
const sal_Char cFontPairs[] = "FontPairs";

const sal_Char cReplaceFont[] 	= "ReplaceFont";
const sal_Char cSubstituteFont[]= "SubstituteFont";
const sal_Char cOnScreenOnly[] 	= "OnScreenOnly";
const sal_Char cAlways[] 		= "Always";

//-----------------------------------------------------------------------------
typedef SubstitutionStruct* SubstitutionStructPtr;
/*N*/ SV_DECL_PTRARR_DEL(SubstitutionStructArr, SubstitutionStructPtr, 2, 2)//STRIP008 ;
/*N*/ SV_IMPL_PTRARR(SubstitutionStructArr, SubstitutionStructPtr);
//-----------------------------------------------------------------------------
/*N*/ struct OfaFontSubstConfig_Impl
/*N*/ {
/*N*/ 	SubstitutionStructArr	aSubstArr;
/*N*/ };
/* -----------------------------18.01.01 12:04--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ OfaFontSubstConfig::OfaFontSubstConfig() :
/*N*/ 	ConfigItem(C2U("Office.Common/Font/Substitution")),
/*N*/ 	bIsEnabled(sal_False),
/*N*/ 	pImpl(new OfaFontSubstConfig_Impl)
/*N*/ {
/*N*/ 	Sequence<OUString> aNames(1);
/*N*/ 	aNames.getArray()[0] = C2U(cReplacement);
/*N*/ 	Sequence<Any> aValues = GetProperties(aNames);
/*N*/ 	DBG_ASSERT(aValues.getConstArray()[0].hasValue(), "no value available");
/*N*/ 	if(aValues.getConstArray()[0].hasValue())
/*N*/ 		bIsEnabled = *(sal_Bool*)aValues.getConstArray()[0].getValue();
/*N*/ 
/*N*/ 	OUString sPropPrefix(C2U(cFontPairs));
/*N*/ 	Sequence<OUString> aNodeNames = GetNodeNames(sPropPrefix);
/*N*/ 	const OUString* pNodeNames = aNodeNames.getConstArray();
/*N*/ 	Sequence<OUString> aPropNames(aNodeNames.getLength() * 4);
/*N*/ 	OUString* pNames = aPropNames.getArray();
/*N*/ 	sal_Int32 nName = 0;
/*N*/ 	sPropPrefix += C2U("/");
/*N*/ 	sal_Int32 nNode;
/*N*/ 	for(nNode = 0; nNode < aNodeNames.getLength(); nNode++)
/*N*/ 	{
/*?*/ 		OUString sStart(sPropPrefix);
/*?*/ 		sStart += pNodeNames[nNode];
/*?*/ 		sStart += C2U("/");
/*?*/ 		pNames[nName] = sStart; 	pNames[nName++] += C2U(cReplaceFont);
/*?*/ 		pNames[nName] = sStart; 	pNames[nName++] += C2U(cSubstituteFont);
/*?*/ 		pNames[nName] = sStart; 	pNames[nName++] += C2U(cAlways);
/*?*/ 		pNames[nName] = sStart; 	pNames[nName++] += C2U(cOnScreenOnly);
/*N*/ 	}
/*N*/ 	Sequence<Any> aNodeValues = GetProperties(aPropNames);
/*N*/ 	const Any* pNodeValues = aNodeValues.getConstArray();
/*N*/ 	nName = 0;
/*N*/ 	for(nNode = 0; nNode < aNodeNames.getLength(); nNode++)
/*N*/ 	{
/*?*/ 		SubstitutionStructPtr pInsert = new SubstitutionStruct;
/*?*/ 		pNodeValues[nName++] >>= pInsert->sFont;
/*?*/ 		pNodeValues[nName++] >>= pInsert->sReplaceBy;
/*?*/ 		pInsert->bReplaceAlways = *(sal_Bool*)pNodeValues[nName++].getValue();
/*?*/ 		pInsert->bReplaceOnScreenOnly = *(sal_Bool*)pNodeValues[nName++].getValue();
/*?*/ 		pImpl->aSubstArr.Insert(pInsert, pImpl->aSubstArr.Count());
/*N*/ 	}
/*N*/ }
/* -----------------------------18.01.01 12:06--------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ OfaFontSubstConfig::~OfaFontSubstConfig()
/*N*/ {
/*N*/ 	delete pImpl;
/*N*/ }
/*-- 18.01.01 12:08:00---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 void OfaFontSubstConfig::Commit()
//STRIP001 {
//STRIP001 	Sequence<OUString> aNames(1);
//STRIP001 	aNames.getArray()[0] = C2U(cReplacement);
//STRIP001 	Sequence<Any> aValues(1);
//STRIP001 	aValues.getArray()[0].setValue(&bIsEnabled, ::getBooleanCppuType());
//STRIP001 	PutProperties(aNames, aValues);
//STRIP001 
//STRIP001 	OUString sNode(C2U(cFontPairs));
//STRIP001 	if(!pImpl->aSubstArr.Count())
//STRIP001 		ClearNodeSet(sNode);
//STRIP001 	else
//STRIP001 	{
//STRIP001 		Sequence<PropertyValue> aSetValues(4 * pImpl->aSubstArr.Count());
//STRIP001 		PropertyValue* pSetValues = aSetValues.getArray();
//STRIP001 		sal_Int32 nSetValue = 0;
//STRIP001 
//STRIP001 		const OUString sReplaceFont(C2U(cReplaceFont));
//STRIP001 		const OUString sSubstituteFont(C2U(cSubstituteFont));
//STRIP001 		const OUString sAlways(C2U(cAlways));
//STRIP001 		const OUString sOnScreenOnly(C2U(cOnScreenOnly));
//STRIP001 
//STRIP001 		const uno::Type& rBoolType = ::getBooleanCppuType();
//STRIP001 		for(sal_uInt16 i = 0; i < pImpl->aSubstArr.Count(); i++)
//STRIP001 		{
//STRIP001 			OUString sPrefix(sNode);
//STRIP001 			sPrefix += C2U("/_");
//STRIP001 			sPrefix += OUString::valueOf((sal_Int32)i);
//STRIP001 			sPrefix += C2U("/");
//STRIP001 
//STRIP001 			SubstitutionStructPtr pSubst = pImpl->aSubstArr[i];
//STRIP001 			pSetValues[nSetValue].Name = sPrefix; pSetValues[nSetValue].Name += sReplaceFont;
//STRIP001 			pSetValues[nSetValue++].Value <<= pSubst->sFont;
//STRIP001 			pSetValues[nSetValue].Name = sPrefix; pSetValues[nSetValue].Name += sSubstituteFont;
//STRIP001 			pSetValues[nSetValue++].Value <<= pSubst->sReplaceBy;
//STRIP001 			pSetValues[nSetValue].Name = sPrefix; pSetValues[nSetValue].Name += sAlways;
//STRIP001 			pSetValues[nSetValue++].Value.setValue(&pSubst->bReplaceAlways, rBoolType);
//STRIP001 			pSetValues[nSetValue].Name = sPrefix; pSetValues[nSetValue].Name += sOnScreenOnly;
//STRIP001 			pSetValues[nSetValue++].Value.setValue(&pSubst->bReplaceOnScreenOnly, rBoolType);
//STRIP001 		}
//STRIP001 		ReplaceSetProperties(sNode, aSetValues);
//STRIP001 	}
//STRIP001 }
/*-- 18.01.01 12:08:00---------------------------------------------------

  -----------------------------------------------------------------------*/
/*N*/sal_Int32 OfaFontSubstConfig::SubstitutionCount() const
/*N*/{
/*N*/	return pImpl->aSubstArr.Count();
/*N*/}
/*-- 18.01.01 12:08:00---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 void OfaFontSubstConfig::ClearSubstitutions()
//STRIP001 {
//STRIP001 	pImpl->aSubstArr.DeleteAndDestroy(0, pImpl->aSubstArr.Count());
//STRIP001 }
/*-- 18.01.01 12:08:00---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 const SubstitutionStruct* OfaFontSubstConfig::GetSubstitution(sal_Int32 nPos)
//STRIP001 {
//STRIP001 	DBG_ASSERT(nPos >= 0 && nPos < pImpl->aSubstArr.Count(), "illegal array index");
//STRIP001 	if(nPos >= 0 && nPos < pImpl->aSubstArr.Count())
//STRIP001 		return pImpl->aSubstArr[(sal_uInt16)nPos];
//STRIP001 	return 0;
//STRIP001 }
/*-- 18.01.01 12:08:01---------------------------------------------------

  -----------------------------------------------------------------------*/
//STRIP001 void OfaFontSubstConfig::AddSubstitution(const SubstitutionStruct& rToAdd)
//STRIP001 {
//STRIP001 	SubstitutionStructPtr pInsert = new SubstitutionStruct(rToAdd);
//STRIP001 	pImpl->aSubstArr.Insert(pInsert, pImpl->aSubstArr.Count());
//STRIP001 }


}
