/*************************************************************************
 *
 *  $RCSfile: sfx2_helpdispatch.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:38:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include "helpdispatch.hxx"
#include "sfxuno.hxx"
#include "newhelp.hxx"

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _COM_SUN_STAR_FRAME_XNOTIFYINGDISPATCH_HPP_
#include <com/sun/star/frame/XNotifyingDispatch.hpp>
#endif
namespace binfilter {

using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::util;

// class HelpInterceptor_Impl --------------------------------------------

//STRIP001 HelpDispatch_Impl::HelpDispatch_Impl( HelpInterceptor_Impl& _rInterceptor,
//STRIP001 									  const ::com::sun::star::uno::Reference<
//STRIP001 									  	::com::sun::star::frame::XDispatch >& _xDisp ) :
//STRIP001 
//STRIP001 	m_rInterceptor	( _rInterceptor ),
//STRIP001 	m_xRealDispatch	( _xDisp )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 HelpDispatch_Impl::~HelpDispatch_Impl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 // XDispatch
//STRIP001 
//STRIP001 void SAL_CALL HelpDispatch_Impl::dispatch(
//STRIP001 
//STRIP001 	const URL& aURL, const Sequence< PropertyValue >& aArgs ) throw( RuntimeException )
//STRIP001 
//STRIP001 {
//STRIP001 	DBG_ASSERT( m_xRealDispatch.is(), "invalid dispatch" );
//STRIP001 
//STRIP001 	// search for a keyword (dispatch from the basic ide)
//STRIP001 	sal_Bool bHasKeyword = sal_False;
//STRIP001 	String sKeyword;
//STRIP001 	const PropertyValue* pBegin = aArgs.getConstArray();
//STRIP001 	const PropertyValue* pEnd	= pBegin + aArgs.getLength();
//STRIP001 	for ( ; pBegin != pEnd; ++pBegin )
//STRIP001 	{
//STRIP001 		if ( 0 == ( *pBegin ).Name.compareToAscii( "HelpKeyword" ) )
//STRIP001 		{
//STRIP001 			::rtl::OUString sHelpKeyword;
//STRIP001 			if ( ( ( *pBegin ).Value >>= sHelpKeyword ) && sHelpKeyword.getLength() > 0 )
//STRIP001 			{
//STRIP001 				sKeyword = String( sHelpKeyword );
//STRIP001 				bHasKeyword = ( sKeyword.Len() > 0 );
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// save url to history
//STRIP001 	m_rInterceptor.addURL( aURL.Complete );
//STRIP001 	// then dispatch
//STRIP001 	SfxHelpWindow_Impl* pHelpWin = m_rInterceptor.GetHelpWindow();
//STRIP001 	DBG_ASSERT( pHelpWin, "invalid HelpWindow" );
//STRIP001 	if ( !bHasKeyword ||
//STRIP001 		 INetURLObject( aURL.Complete ).GetHost() != pHelpWin->GetFactory() )
//STRIP001 	{
//STRIP001         Reference < XNotifyingDispatch > xNotifyingDisp( m_xRealDispatch, UNO_QUERY );
//STRIP001         if ( xNotifyingDisp.is() )
//STRIP001         {
//STRIP001         	OpenStatusListener_Impl* pListener = (OpenStatusListener_Impl*)pHelpWin->getOpenListener().get();
//STRIP001         	DBG_ASSERT( pListener, "invalid XDispatchResultListener" );
//STRIP001         	pListener->SetURL( aURL.Complete );
//STRIP001         	xNotifyingDisp->dispatchWithNotification( aURL, aArgs, pListener );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	// if a keyword was found, then open it
//STRIP001 	if ( bHasKeyword )
//STRIP001 		pHelpWin->OpenKeyword( sKeyword );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SAL_CALL HelpDispatch_Impl::addStatusListener(
//STRIP001 
//STRIP001 	const Reference< XStatusListener >& xControl, const URL& aURL ) throw( RuntimeException )
//STRIP001 
//STRIP001 {
//STRIP001 	DBG_ASSERT( m_xRealDispatch.is(), "invalid dispatch" );
//STRIP001 	m_xRealDispatch->addStatusListener( xControl, aURL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SAL_CALL HelpDispatch_Impl::removeStatusListener(
//STRIP001 
//STRIP001 	const Reference< XStatusListener >& xControl, const URL& aURL ) throw( RuntimeException )
//STRIP001 
//STRIP001 {
//STRIP001 	DBG_ASSERT( m_xRealDispatch.is(), "invalid dispatch" );
//STRIP001 	m_xRealDispatch->removeStatusListener( xControl, aURL );
//STRIP001 }

}
