/*************************************************************************
 *
 *  $RCSfile: svx_tabarea.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#pragma hdrstop
#include <tools/ref.hxx>
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
#ifndef _SFX_OBJSH_HXX //autogen
#include <bf_sfx2/objsh.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
#ifndef _SVDMARK_HXX //autogen
#include <svdmark.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svdobj.hxx>
#endif
#ifndef _SVDVIEW_HXX //autogen
#include <svdview.hxx>
#endif

#define _SVX_TABAREA_CXX

#include "dialogs.hrc"

#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE
#define ITEMID_GRADIENT_LIST	SID_GRADIENT_LIST
#define ITEMID_HATCH_LIST		SID_HATCH_LIST
#define ITEMID_BITMAP_LIST		SID_BITMAP_LIST

#include "xtable.hxx"
#include "globl3d.hxx"
#include "svdmodel.hxx"
#include "drawitem.hxx"
#include "tabarea.hxx"
#include "tabarea.hrc"
#include "dlgname.hxx"
#include "dlgname.hrc"
#include "dialmgr.hxx"
namespace binfilter {

//STRIP001 #define DLGWIN this->GetParent()->GetParent()

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
|************************************************************************/

//STRIP001 SvxAreaTabDialog::SvxAreaTabDialog
//STRIP001 (
//STRIP001 	Window* pParent,
//STRIP001 	const SfxItemSet* pAttr,
//STRIP001 	SdrModel* pModel,
//STRIP001 	const SdrView* pSdrView
//STRIP001 ) :
//STRIP001 
//STRIP001 	SfxTabDialog( pParent, SVX_RES( RID_SVXDLG_AREA ), pAttr ),
//STRIP001 
//STRIP001 	rOutAttrs			( *pAttr ),
//STRIP001 	pDrawModel			( pModel ),
//STRIP001 	pView     			( pSdrView ),
//STRIP001 	pColorTab			( pModel->GetColorTable() ),
//STRIP001 	pGradientList  		( pModel->GetGradientList() ),
//STRIP001 	pHatchingList  		( pModel->GetHatchList() ),
//STRIP001 	pBitmapList  		( pModel->GetBitmapList() ),
//STRIP001 	pNewColorTab		( pModel->GetColorTable() ),
//STRIP001 	pNewGradientList	( pModel->GetGradientList() ),
//STRIP001 	pNewHatchingList	( pModel->GetHatchList() ),
//STRIP001 	pNewBitmapList 		( pModel->GetBitmapList() ),
//STRIP001 	bDeleteColorTable	( TRUE )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	AddTabPage( RID_SVXPAGE_AREA, SvxAreaTabPage::Create, 0 );
//STRIP001 	AddTabPage( RID_SVXPAGE_SHADOW, SvxShadowTabPage::Create, 0 );
//STRIP001 	AddTabPage( RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create,  0);
//STRIP001 	AddTabPage( RID_SVXPAGE_COLOR, SvxColorTabPage::Create, 0 );
//STRIP001 	AddTabPage( RID_SVXPAGE_GRADIENT, SvxGradientTabPage::Create, 0 );
//STRIP001 	AddTabPage( RID_SVXPAGE_HATCH, SvxHatchTabPage::Create, 0 );
//STRIP001 	AddTabPage( RID_SVXPAGE_BITMAP, SvxBitmapTabPage::Create,  0);
//STRIP001 
//STRIP001 	nColorTableState = CT_NONE;
//STRIP001 	nBitmapListState = CT_NONE;
//STRIP001 	nGradientListState = CT_NONE;
//STRIP001 	nHatchingListState = CT_NONE;
//STRIP001 
//STRIP001 	nDlgType = 0;
//STRIP001 	nPageType = PT_AREA;
//STRIP001 	nPos = 0;
//STRIP001 
//STRIP001 	SetCurPageId( RID_SVXPAGE_AREA );
//STRIP001 
//STRIP001 	CancelButton& rBtnCancel = GetCancelButton();
//STRIP001 	rBtnCancel.SetClickHdl( LINK( this, SvxAreaTabDialog, CancelHdl ) );
//STRIP001 //! rBtnCancel.SetText( SVX_RESSTR( RID_SVXSTR_CLOSE ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxAreaTabDialog::~SvxAreaTabDialog()
//STRIP001 {
//STRIP001 }


// -----------------------------------------------------------------------

//STRIP001 void SvxAreaTabDialog::SavePalettes()
//STRIP001 {
//STRIP001 	if( pNewColorTab != pDrawModel->GetColorTable() )
//STRIP001 	{
//STRIP001 		if(bDeleteColorTable)
//STRIP001 			delete pDrawModel->GetColorTable();
//STRIP001 		pDrawModel->SetColorTable( pNewColorTab );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxColorTableItem( pNewColorTab ) );
//STRIP001 		pColorTab = pDrawModel->GetColorTable();
//STRIP001 	}
//STRIP001 	if( pNewGradientList != pDrawModel->GetGradientList() )
//STRIP001 	{
//STRIP001 		delete pDrawModel->GetGradientList();
//STRIP001 		pDrawModel->SetGradientList( pNewGradientList );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxGradientListItem( pNewGradientList ) );
//STRIP001 		pGradientList = pDrawModel->GetGradientList();
//STRIP001 	}
//STRIP001 	if( pNewHatchingList != pDrawModel->GetHatchList() )
//STRIP001 	{
//STRIP001 		delete pDrawModel->GetHatchList();
//STRIP001 		pDrawModel->SetHatchList( pNewHatchingList );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxHatchListItem( pNewHatchingList ) );
//STRIP001 		pHatchingList = pDrawModel->GetHatchList();
//STRIP001 	}
//STRIP001 	if( pNewBitmapList != pDrawModel->GetBitmapList() )
//STRIP001 	{
//STRIP001 		delete pDrawModel->GetBitmapList();
//STRIP001 		pDrawModel->SetBitmapList( pNewBitmapList );
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxBitmapListItem( pNewBitmapList ) );
//STRIP001 		pBitmapList = pDrawModel->GetBitmapList();
//STRIP001 	}
//STRIP001 
//STRIP001 	// Speichern der Tabellen, wenn sie geaendert wurden.
//STRIP001 
//STRIP001 	const String aPath( SvtPathOptions().GetPalettePath() );
//STRIP001 
//STRIP001 	if( nHatchingListState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pHatchingList->SetPath( aPath );
//STRIP001 		pHatchingList->Save();
//STRIP001 
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxHatchListItem( pHatchingList ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nBitmapListState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pBitmapList->SetPath( aPath );
//STRIP001 		pBitmapList->Save();
//STRIP001 
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxBitmapListItem( pBitmapList ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nGradientListState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pGradientList->SetPath( aPath );
//STRIP001 		pGradientList->Save();
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxGradientListItem( pGradientList ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nColorTableState & CT_MODIFIED )
//STRIP001 	{
//STRIP001 		pColorTab->SetPath( aPath );
//STRIP001 		pColorTab->Save();
//STRIP001 
//STRIP001 		// ToolBoxControls werden benachrichtigt:
//STRIP001 		SfxObjectShell::Current()->PutItem( SvxColorTableItem( pColorTab ) );
//STRIP001 	}
//STRIP001 }
// -----------------------------------------------------------------------

//STRIP001 short SvxAreaTabDialog::Ok()
//STRIP001 {
//STRIP001 	SavePalettes();
//STRIP001 
//STRIP001 	// Es wird RET_OK zurueckgeliefert, wenn wenigstens eine
//STRIP001 	// TabPage in FillItemSet() TRUE zurueckliefert. Dieses
//STRIP001 	// geschieht z.Z. standardmaessig.
//STRIP001 	return( SfxTabDialog::Ok() );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK_INLINE_START( SvxAreaTabDialog, CancelHdl, void *, p )
//STRIP001 {
//STRIP001 	SavePalettes();
//STRIP001 
//STRIP001 	EndDialog( RET_CANCEL );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SvxAreaTabDialog, CancelHdl, void *, p )

// -----------------------------------------------------------------------

//STRIP001 void SvxAreaTabDialog::PageCreated( USHORT nId, SfxTabPage &rPage )
//STRIP001 {
//STRIP001 	switch( nId )
//STRIP001 	{
//STRIP001 		case RID_SVXPAGE_AREA:
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetGradientList( pGradientList );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetHatchingList( pHatchingList );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetBitmapList( pBitmapList );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetGrdChgd( &nGradientListState );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetHtchChgd( &nHatchingListState );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetBmpChgd( &nBitmapListState );
//STRIP001 			( (SvxAreaTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxAreaTabPage&) rPage ).Construct();
//STRIP001 			// ActivatePage() wird das erste mal nicht gerufen
//STRIP001 			( (SvxAreaTabPage&) rPage ).ActivatePage( rOutAttrs );
//STRIP001 
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_SHADOW:
//STRIP001 		{
//STRIP001 			( (SvxShadowTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxShadowTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxShadowTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			//( (SvxShadowTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxShadowTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxShadowTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxShadowTabPage&) rPage ).Construct();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_GRADIENT:
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetGradientList( pGradientList );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetGrdChgd( &nGradientListState );
//STRIP001 			( (SvxGradientTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxGradientTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_HATCH:
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetHatchingList( pHatchingList );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetHtchChgd( &nHatchingListState );
//STRIP001 			( (SvxHatchTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxHatchTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_BITMAP:
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetBitmapList( pBitmapList );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetBmpChgd( &nBitmapListState );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxBitmapTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_COLOR:
//STRIP001 			( (SvxColorTabPage&) rPage ).SetColorTable( pColorTab );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetPos( &nPos );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetAreaTP( &bAreaTP );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetColorChgd( &nColorTableState );
//STRIP001 			( (SvxColorTabPage&) rPage ).SetDeleteColorTable( bDeleteColorTable );
//STRIP001 			( (SvxColorTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_TRANSPARENCE:
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).Construct();
//STRIP001 		break;
//STRIP001 
//STRIP001 	}
//STRIP001 }


}
