/*************************************************************************
 *
 *  $RCSfile: charmap.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:08:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_CHARMAP_HXX
#define _SVX_CHARMAP_HXX

// include ---------------------------------------------------------------

#ifndef _SV_CTRL_HXX
#include <vcl/ctrl.hxx>
#endif
#ifndef _SV_METRIC_HXX
#include <vcl/metric.hxx>
#endif
#ifndef _SV_SCRBAR_HXX
#include <vcl/scrbar.hxx>
#endif

// auto strip #ifndef _BASEDLGS_HXX
// auto strip #include <bf_sfx2/basedlgs.hxx>
// auto strip #endif
#include <map>
namespace binfilter {

class SubsetMap;
class SvxCharMapData;

// define ----------------------------------------------------------------

#ifdef MAC
#define CHARMAP_MAXLEN  28
#define COLUMN_COUNT    28
#define ROW_COUNT        8
#else
#define CHARMAP_MAXLEN  32
#define COLUMN_COUNT    16
#define ROW_COUNT        8
#endif

namespace svx
{
	struct SvxShowCharSetItem;
	class SvxShowCharSetVirtualAcc;
}

// class SvxShowCharSet --------------------------------------------------

//STRIP001 class SvxShowCharSet : public Control
//STRIP001 {
//STRIP001 public:
//STRIP001 					SvxShowCharSet( Window* pParent, const ResId& rResId );
//STRIP001 					~SvxShowCharSet();
//STRIP001 
//STRIP001 	void            SetFont( const Font& rFont );
//STRIP001 
//STRIP001 	void            SelectCharacter( sal_Unicode cNew, BOOL bFocus = FALSE );
//STRIP001 	sal_Unicode     GetSelectCharacter() const;
//STRIP001 
//STRIP001 	Link            GetDoubleClickHdl() const { return aDoubleClkHdl; }
//STRIP001 	void			SetDoubleClickHdl( const Link& rLink ) { aDoubleClkHdl = rLink; }
//STRIP001 	Link            GetSelectHdl() const { return aSelectHdl; }
//STRIP001 	void            SetSelectHdl( const Link& rHdl ) { aSelectHdl = rHdl; }
//STRIP001 	Link            GetHighlightHdl() const { return aHighHdl; }
//STRIP001 	void            SetHighlightHdl( const Link& rHdl )	{ aHighHdl = rHdl; }
//STRIP001 	Link            GetPreSelectHdl() const { return aHighHdl; }
//STRIP001 	void            SetPreSelectHdl( const Link& rHdl )	{ aPreSelectHdl = rHdl; }
//STRIP001 
//STRIP001 #ifdef _SVX_CHARMAP_CXX_
//STRIP001 	::svx::SvxShowCharSetItem*	ImplGetItem( USHORT _nPos );
//STRIP001 	int							FirstInView( void) const;
//STRIP001 	int							LastInView( void) const;
//STRIP001 	int							PixelToMapIndex( const Point&) const;
//STRIP001 	void						SelectIndex( int index, BOOL bFocus = FALSE );
//STRIP001 	void						DeSelect();
//STRIP001 	inline sal_Bool				IsSelected(USHORT _nPos) const { return _nPos == nSelectedIndex; } 
//STRIP001 	inline USHORT				GetSelectIndexId() const { return nSelectedIndex; }
//STRIP001 	USHORT						GetRowPos(USHORT _nPos) const;
//STRIP001 	USHORT						GetColumnPos(USHORT _nPos) const;
//STRIP001 	
//STRIP001 	void						ImplFireAccessibleEvent( short nEventId, 
//STRIP001 														 const ::com::sun::star::uno::Any& rOldValue, 
//STRIP001 														 const ::com::sun::star::uno::Any& rNewValue );
//STRIP001 	ScrollBar*					getScrollBar();
//STRIP001 	void						ReleaseAccessible();
//STRIP001 	sal_Int32					getMaxCharCount() const;
//STRIP001 #endif // _SVX_CHARMAP_CXX_
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void    Paint( const Rectangle& );
//STRIP001 	virtual void    MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void    MouseButtonUp( const MouseEvent& rMEvt );
//STRIP001 	virtual void    MouseMove( const MouseEvent& rMEvt );
//STRIP001 	virtual void    Command( const CommandEvent& rCEvt );
//STRIP001 	virtual void    KeyInput( const KeyEvent& rKEvt );
//STRIP001 	virtual void    GetFocus();
//STRIP001 	virtual void    LoseFocus();
//STRIP001 	virtual void	StateChanged( StateChangedType nStateChange );
//STRIP001 	virtual void	DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 
//STRIP001     virtual ::com::sun::star::uno::Reference< ::com::sun::star::accessibility::XAccessible > CreateAccessible();
//STRIP001 
//STRIP001 	
//STRIP001 
//STRIP001 private:
//STRIP001 	typedef ::std::map<sal_Int32, ::svx::SvxShowCharSetItem*> ItemsMap;
//STRIP001 	ItemsMap		m_aItems;
//STRIP001 	Link            aDoubleClkHdl;
//STRIP001 	Link            aSelectHdl;
//STRIP001 	Link            aHighHdl;
//STRIP001 	Link			aPreSelectHdl;
//STRIP001 	::svx::SvxShowCharSetVirtualAcc*	m_pAccessible;
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::accessibility::XAccessible > m_xAccessible;
//STRIP001 	long	        nX;
//STRIP001 	long			nY;
//STRIP001 	BOOL            bDrag;
//STRIP001 
//STRIP001 	sal_Int32		nSelectedIndex; 
//STRIP001 
//STRIP001     FontCharMap     maFontCharMap;
//STRIP001     ScrollBar       aVscrollSB;
//STRIP001     Size            aOrigSize;
//STRIP001     Point           aOrigPos;
//STRIP001 
//STRIP001 private:
//STRIP001     void            DrawChars_Impl( int n1, int n2);
//STRIP001     void            InitSettings( BOOL bForeground, BOOL bBackground);
//STRIP001     // abstraction layers are: Unicode<->MapIndex<->Pixel
//STRIP001     Point           MapIndexToPixel( int) const;
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( VscrollHdl, ScrollBar* );
//STRIP001 #endif
//STRIP001 };

// class SvxCharacterMap -------------------------------------------------
// the main purpose of this dialog is to enable the use of characters
// that are not easily accesible from the keyboard

class SvxCharacterMap //STRIP001 : public SfxModalDialog
{
private:
//STRIP001     SvxCharMapData* const mpCharMapData;

public:
                    SvxCharacterMap( Window* pParent, BOOL bOne = TRUE );
                    ~SvxCharacterMap();

    void            DisableFontSelection();

//STRIP001     const Font&     GetCharFont() const;
    void            SetCharFont( const Font& rFont );
    void            SetFont( const Font& rFont ) { DBG_BF_ASSERT(0, "STRIP");} //STRIP001 SetCharFont( rFont ); } //! irgendwann entfernen

//STRIP001     void            SetChar( sal_Unicode c );
//STRIP001     sal_Unicode     GetChar() const;

    String          GetCharacters() const;
};

}//end of namespace binfilter
#endif

