/*************************************************************************
 *
 *  $RCSfile: e3dundo.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _E3D_UNDO_HXX
#define _E3D_UNDO_HXX

#ifndef _SVDUNDO_HXX
#include <bf_svx/svdundo.hxx>
#endif
class E3DObject;
#ifndef _E3D_SCENE3D_HXX
#include <bf_svx/scene3d.hxx>
#endif
namespace binfilter {

class E3dView;

/************************************************************************\
|*
|* Basisklasse fuer alle 3D-Undo-Aktionen.
|*
\************************************************************************/
//STRIP001 class E3dUndoAction : public SdrUndoAction
//STRIP001 {
//STRIP001 
//STRIP001 	protected :
//STRIP001 		E3dObject *pMy3DObj;
//STRIP001 
//STRIP001 	public:
//STRIP001 		TYPEINFO();
//STRIP001 		E3dUndoAction (SdrModel  *pModel,
//STRIP001 					   E3dObject *p3DObj) :
//STRIP001 			SdrUndoAction (*pModel),
//STRIP001 			pMy3DObj (p3DObj)
//STRIP001 			{
//STRIP001 			}
//STRIP001 
//STRIP001 		virtual ~E3dUndoAction ();
//STRIP001 
//STRIP001 		virtual BOOL CanRepeat(SfxRepeatTarget&) const;
//STRIP001 };

/************************************************************************\
|*
|* Undo fuer 3D-Rotation ueber die Rotationsmatrizen (ob das wohl klappt ?)
|*
\************************************************************************/
//STRIP001 class E3dRotateUndoAction : public E3dUndoAction
//STRIP001 {
//STRIP001 		Matrix4D aMyOldRotation;
//STRIP001 		Matrix4D aMyNewRotation;
//STRIP001 
//STRIP001 	public:
//STRIP001 		TYPEINFO();
//STRIP001 		E3dRotateUndoAction (SdrModel       *pModel,
//STRIP001 							 E3dObject      *p3DObj,
//STRIP001 							 const Matrix4D &aOldRotation,
//STRIP001 							 const Matrix4D &aNewRotation) :
//STRIP001 			E3dUndoAction (pModel, p3DObj),
//STRIP001 			aMyOldRotation (aOldRotation),
//STRIP001 			aMyNewRotation (aNewRotation)
//STRIP001 			{
//STRIP001 			}
//STRIP001 
//STRIP001 		virtual ~E3dRotateUndoAction ();
//STRIP001 
//STRIP001 		virtual void Undo();
//STRIP001 		virtual void Redo();
//STRIP001 
//STRIP001 };

/************************************************************************\
|*
|* Undo fuer 3D-Attribute (Implementiert ueber Set3DAttributes())
|*
\************************************************************************/
//STRIP001 class E3dAttributesUndoAction : public SdrUndoAction
//STRIP001 {
//STRIP001 	SdrObject*	pObject;
//STRIP001 	E3dView*	pView;
//STRIP001 	BOOL		bUseSubObjects;
//STRIP001 
//STRIP001 	const SfxItemSet aNewSet;
//STRIP001 	const SfxItemSet aOldSet;
//STRIP001 
//STRIP001  public:
//STRIP001 		TYPEINFO();
//STRIP001 		E3dAttributesUndoAction( SdrModel &rModel, E3dView*	pView,
//STRIP001 			E3dObject* pInObject,
//STRIP001 			const SfxItemSet& rNewSet,
//STRIP001 			const SfxItemSet& rOldSet,
//STRIP001 			BOOL bUseSubObj);
//STRIP001 
//STRIP001 		virtual ~E3dAttributesUndoAction();
//STRIP001 
//STRIP001 		virtual BOOL CanRepeat(SfxRepeatTarget& rView) const;
//STRIP001 		virtual void Undo();
//STRIP001 		virtual void Redo();
//STRIP001 		virtual void Repeat();
//STRIP001 };

}//end of namespace binfilter
#endif			// _E3D_CUBE3D_HXX
